// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UEdGraphNode.h"
#include "ISCW_UK2Node.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UK2Node_CreateDelegate : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_CreateDelegate() = default;
		
		virtual wstring GetFunctionName() const = 0;

		virtual void HandleAnyChange(bool bForceModify = false) = 0;

		virtual shared_ptr<ISCW_UK2Node_CreateDelegate> ToUK2Node_CreateDelegatePtr() = 0;
		virtual shared_ptr<const ISCW_UK2Node_CreateDelegate> ToUK2Node_CreateDelegatePtr() const = 0;

		virtual ISCW_UEdGraphPinPtr GetDelegateOutPin() const = 0;

		virtual void SetFunction(wstring Name) const = 0;
	};

	using ISCW_UK2Node_CreateDelegateConstPtr = shared_ptr<const ISCW_UK2Node_CreateDelegate>;
	using ISCW_UK2Node_CreateDelegatePtr = shared_ptr<ISCW_UK2Node_CreateDelegate>;
} // namespace Sourcify